<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjs/10.5.2/math.js" 
    integrity="sha512-vdwP2fMacZZUetdvY+t/hsPJfEeifOcTBv0zYwUyj5qj3NbMvIFg87DxanM5dwqpu4yZkPry5VZv9TnQrll6tg==" 
    crossorigin="anonymous" 
    referrerpolicy="no-referrer"></script>
</head>
<body>
    <div align="center">
    <div id="app"></div>
<input type="file" onchange="readFile(this)">
<script>

// Обозначение обязательных параметров для сети, типа (нейронов), нейронов и синапсов
network = ['идентификатор']
typ = ['идентификатор', 'константа']
neuron = ['идентификатор']
synaps = ['идентификатор', 'приемник', "передатчик", "вес"]

// Объект Map (словарь), где присутствуют все сущности, согласно INSML и их всевозможные параметры
let keywords_params = new Map([
  ['тип', [
'имя',
'идентификатор',
'описание',
'состояние',
'цвет',
'константа',
'аккумулятор',
'активация']],
  ['синапс', [
'имя',
'идентификатор',
'описание',
'состояние',
'приемник',
'передатчик',
'функция',
'координаты',
'задержка',
'вес',]],
  ['нейрон', [
'имя',
'тип',
'идентификатор',
'описание',
'состояние',
'координаты',
'цвет',
'константа',
'x',
'y',
'вх_файл',
'вых_файл',
'аккумулятор',
'активация',]],
  ['сеть', [
'идентификатор',
'автор',
'координаты',
'цвет',
'цвет_н',
'цвет_с',
'состояние',
'дата',
'имя',
'описание',
'активация',
'аккумулятор',
'функция',
'передатчик',
'приемник']]
]);

// Массив сущностей
key_arr = [];
// Временный массив сущностей
tmp_key_arr = [];

// Реальные найденные параметры для каждой из сущностей (сеть, тип, нейрон, синапс)
current_params_network = [];
current_params_typ = [];
current_params_neuron = [];
current_params_synaps = [];

// Количества сущностей (сеть, тип, нейрон, синапс)
networks = 0;
typs = 0;
neurons = 0;
synaps = 0;

// Регулярное выражение для поиска значений между открывающим и закрывающим тегами в строке
let regexp = />(.*?)</g;
let file_ext1 = /\.insml/g;
let file_ext2 = /\.insmldump/g;

// Проверочные булевы переменные
VALID = true;
NESS_VALID = true;
EMPTY_VALID = true;
FM_VALID = true;
KNOWN_TAG = true;

// Главная функция для чтения и проверки корректного описания INSML файла
function readFile(input) {
  // Инициализируем файл в переменной file и читаем содержимое как текстовые данные
  let file = input.files[0];
  let reader = new FileReader();
  if (file_ext1.test(file.name) || file_ext2.test(file.name)) {
    // Продолжаем процесс чтения файла, если расширение подходящее
  } else {
    return console.log('Неверный формат файла, доступные: .insml или .insmldump')
  }
  reader.readAsText(file);
  reader.onload = function() {
    // source - исходный текст, разбиваем его по \n, чтобы получить массив из элементов-строк
    let source = reader.result.split('\n');


// Очищаем элементы массива от лишних пробелов
source = source.map(function(elem) {
  return elem.split(' ').join('');;
});

// Удаление пустых строк
source = source.filter(function(elem) { 
  return elem.trim() != ''; 
});
// console.log(source)


// Функция, проверяющая наличие открывающих и закрывающих тегов для параметров
function prove_full_tags(Entity, VALID) {
  for (let param of keywords_params.get(Entity)) {
      if ( row.startsWith('<'+param+'>')
        && row.endsWith('</'+param+'>') ) {
          // console.log(row, Entity, param)
        } else if ( row.startsWith('<'+param+'>') && !row.endsWith('</'+param+'>')) {
          console.log("Не хватает закрывающего тега для параметра, строка №", source.indexOf(row)+1)
          console.log(row)
        VALID = false;
        break;
        
        } else if ( !row.startsWith('<'+param+'>') && row.endsWith('</'+param+'>') ) {
                  console.log("Не хватает открывающего тега для параметра, строка №", source.indexOf(row)+1)
                  console.log(row)
        VALID = false;
        break;
        }
  }
  return VALID;
}


// Функция создания массива, состоящего из параметров, которые реально присутствуют у сущности
function current_params(key_arr, entity, keywords_params, list){
  if (key_arr[key_arr.length - 1] == '<' + entity + '>') {
      for (let param of keywords_params.get(entity)) {
        if (row.includes(param)) {
          list.push(param)
        }
      }
    }
  return list
}


// Функция подсчета количества встретившихся параметров у всех сущностей
function counts_params(arr_params){
  counts_par = {}
  for (let i = 0; i < arr_params.length; i++) {
    let num = arr_params[i];
    counts_par[num] = counts_par[num] ? counts_par[num] + 1 : 1;
  }
  return counts_par
}


let index = 1;
// Чтение построчно
for ( row of source ) {
  let known = 0;
  for (let Entity of keywords_params.keys()) {
    if (row.includes(Entity)) {
      known = 1;
    }
  }

  // Для каждой сущности проверяем наличие открывающего и закрывающего тега
  for (let Entity of keywords_params.keys()) {
  // Добавляем новую сущность в массивы для запоминания и последующего удаления,
  // если найдутся все соответствующие закрывающие теги
    if (row.startsWith('<'+Entity+'>') ) {
      key_arr.push(row)
      tmp_key_arr.push(row)
    } else if (row.endsWith('</'+Entity+'>') ) {
      key_arr.pop('<'+Entity+'>')
    }

  // Проверка на корректность открывающих/закрывающих тегов для параметров
    VALID = prove_full_tags(Entity, VALID);


  // Если обнаружена ошибка, выходим из цикла, предварительно обнулив список найденных сущностей
    if (!VALID) {
      key_arr = [];
      break;
    }
  }

  // Продолжение чтения строк...
  // Подсчет количества сущностей
  if (tmp_key_arr[0] == '<сеть>') {
      networks += 1;
    } else if (tmp_key_arr[0] == '<нейрон>') {
      neurons += 1;
    } else if (tmp_key_arr[0] == '<тип>') {
      typs += 1;
    } else if (tmp_key_arr[0] == '<синапс>') {
      synaps += 1;
    }

  // Получение списков реальных (текущих) параметров для каждой из найденных сущностей
  current_params_network = current_params(key_arr, 'сеть', keywords_params, current_params_network)
  current_params_typ = current_params(key_arr, 'тип', keywords_params, current_params_typ)
  current_params_neuron = current_params(key_arr, 'нейрон', keywords_params, current_params_neuron)
  current_params_synaps = current_params(key_arr, 'синапс', keywords_params, current_params_synaps)

  // console.log(current_params_network, current_params_neuron, current_params_typ, current_params_synaps)
  
  // Формирование словарей параметров для каждой сущности и их количества в файле
  counts_params_network = counts_params(current_params_network)
  counts_params_typ = counts_params(current_params_typ)
  counts_params_neuron = counts_params(current_params_neuron)
  counts_params_synaps = counts_params(current_params_synaps)

  // console.log(counts_params_neuron)

  let matchAll = row.matchAll(regexp);

  // matchAll не массив, а перебираемый объект

  matchAll = Array.from(matchAll); // теперь массив

  f_match = matchAll[0];
  // Если возможно из строки извлечь значение между символами > и < (для параметров), проверяем на пустоту (незаполненность)
  if (typeof f_match != 'undefined') {
    if (f_match[1] == '') {
      console.log('Строка № ', index)
      EMPTY_VALID = false
    }
    if (row.includes('активация') && f_match[1].includes(';')) {
      formula = f_match[1];
      formula = formula.split(';')
      try {
        if (!formula[0].includes('accum') && !formula[0].includes('input') && !formula[0].includes('output')){
          math.evaluate(formula[0])
        }
      } catch (err) {
        console.log('Строка № ', index)
        console.log(row)
        FM_VALID = false
      }
    } else if (row.includes('активация') && !row.includes(';')){
      console.log('Не хватает разделителя ; в параметре <активация>', '\nСтрока № ', index)
      console.log(row)
      FM_VALID = false
    }
  }
 
  if (key_arr.length > 0){
  for (let param of keywords_params.get(key_arr[key_arr.length - 1].slice(1,-1))) {
    if (row.includes(param)) {
      known = 1;
    }
  }
}

  tmp_key_arr = []
  index += 1;
  // Выходим из цикла чтения при выявлении ошибки
  if (!VALID) {
      break;
    }
    if (known == 1){
    // Найден известный параметр
  } else if (known == 0){
    console.log('В строке № ', index)
    console.log(row)
    KNOWN_TAG = false;
    key_arr = [];
    break;
  }
}
// Повторное чтение построчно, но уже с известным количеством сущностей в файле
// Проверка на обязательные параметры
// Например, количество идентификаторов должно совпадать с количеством нейронов
for (row of source) {
  if (KNOWN_TAG) {
    if (counts_params_network['идентификатор'] != networks && 'идентификатор' in counts_params_network) {
      NESS_VALID = false;
      msg = 'Для сущности сеть (параметр идентификатор)'
    } else  if (counts_params_typ['идентификатор'] != typs && 'идентификатор' in counts_params_typ) {
      NESS_VALID = false;
      msg = 'Для сущности тип (параметр идентификатор)'
    } else  if (counts_params_neuron['идентификатор'] != neurons && 'идентификатор' in counts_params_neuron) {
      NESS_VALID = false;
      msg = 'Для сущности нейрон (параметр идентификатор)'
    } else  if (counts_params_synaps['идентификатор'] != synaps && 'идентификатор' in counts_params_synaps) {
      NESS_VALID = false;
      msg = 'Для сущности синапс (параметр идентификатор)'
    } else  if (counts_params_typ['константа'] != typs && 'константа' in counts_params_typ) {
      NESS_VALID = false;
      msg = 'Для сущности тип (параметр константа)'
    } else  if (counts_params_synaps['приемник'] != synaps && 'приемник' in counts_params_synaps) {
      NESS_VALID = false;
      msg = 'Для сущности синапс (параметр приемник)'
    } else  if (counts_params_synaps['передатчик'] != synaps && 'передатчик' in counts_params_synaps) {
      NESS_VALID = false;
      msg = 'Для сущности синапс (параметр передатчик)'
    } else  if (counts_params_synaps['вес'] != synaps && 'вес' in counts_params_synaps) {
      NESS_VALID = false;
      msg = 'Для сущности синапс (параметр вес)'
    }
  }
}

// Итоговая проверка
if ( key_arr.length > 0 ) {
  for (let n=0; key_arr.length > n; n++) {
    if (n%2 == 0) {
        console.log("Не хватает парного тега для сущности ")
    }
  }
} else if (!KNOWN_TAG) {
  console.log('Неподходящий параметр или сущность')
} else if (!NESS_VALID) {
  console.log(msg)
  console.log('Отсутствует обязательный тег')
}  else if (!EMPTY_VALID) {
  console.log('Обнаружен параметр с пустым значением')
} else if (!FM_VALID) {
  console.log('Ошибка в формуле')
} else if (VALID) {
  console.log('Кажется, все в порядке')
} else {
  console.log('Что-то пошло не так')
}
}
reader.onerror = function() {
    console.log(reader.error);
  };
};
</script>
</div>
</body>
</html>
