
function translator(data, file_language, target_language) {
    insml_dictionary = {
      'neuron': ['neuron', 'нейрон', '神經元'],
      'name': ['name', 'имя', '姓名'],
      'type': ['type', 'тип', '類型'],
      'id': ['id', 'идентификатор', 'ID'],
      'description': ['description', 'описание', '描述'],
      'condition': ['condition', 'состояние', '狀況'],
      'coordinates': ['coordinates', 'координаты', '坐標'],
      'colour': ['colour', 'цвет', '顏色'],
      'constant': ['constant', 'константа', '持續的'],
      'input_file': ['input_file', 'вх_файл', '輸入文件'],
      'output_file': ['output_file', 'вых_файл', '輸出文件'],
      'accumulator': ['accumulator', 'аккумулятор', '累加器'],
      'activation': ['activation', 'активация', '激活'],
      'synapse': ['synapse', 'синапс', '突觸'],
      'receiver': ['receiver', 'приемник', '接收者'],
      'transmitter': ['transmitter', 'передатчик', '發射機'],
      'function': ['function', 'функция', '功能'],
      'delay': ['delay', 'задержка', '延遲'],
      'weight': ['weight', 'вес', '重量'],
      'network': ['network', 'сеть', '網絡'],
      'author': ['author', 'автор', '作者'],
      'color_n': ['color_n', 'цвет_н', '顏色神經元'],
      'color_s': ['color_s', 'цвет_с', '顏色突觸'],
      'date': ['date', 'дата', '日期']
    }
    function encode_language(language) {
        if (language == 'en') return 0;
        else if (language == 'rus') return 1;
        else return 2;
    }
 
    let current_word_position = encode_language(file_language);
    let target_word_position = encode_language(target_language);
    for (const key of Object.keys(insml_dictionary)) {
        let new_key = insml_dictionary[key][current_word_position];
        let new_value = insml_dictionary[key][target_word_position];
        delete insml_dictionary[key];
        insml_dictionary[new_key] = new_value;
    }
    data = data.replaceAll('>', '> # ');
    let translated_data = '';
    let end_of_previous = 0;
    const regexp = /<\S+>/g;
    const matches = data.matchAll(regexp);
    for (const match of matches) {
        let current_word = match[0];
        current_word = current_word.replace('<', '');
        current_word = current_word.replace('>', '');
        let changed = 0;
        if (current_word.length != current_word.replace('/', '').length) {
            changed = 1;
            current_word = current_word.replace('/', '');
        }
        let tanslated_current_word = '';
        if (insml_dictionary[current_word] == undefined) tanslated_current_word = current_word;
        else tanslated_current_word = insml_dictionary[current_word];

        if (changed == 0) tanslated_current_word = '<' + tanslated_current_word + '>';
        else tanslated_current_word = '</' + tanslated_current_word + '>';
        translated_data= translated_data + data.slice(end_of_previous, match.index) + tanslated_current_word;
        end_of_previous = match.index + match[0].length;
    }
    translated_data= translated_data.replaceAll(' # ', '');
    return translated_data;
}
